#include <allegro.h>

class Screen {
public:		
	int page;	
	int w, h;
	BITMAP *framebuffer, *background;
	int rect(int, int, int, int, char);
	int blit(int, int, int, int, int, int);
	int sync();
};

class Sound {
public:
	int len[256];
	int freq[256];
	int mult[256];
	unsigned char *data[256];	
	int num;
};

class Game {
public:			
	virtual const char * name() = 0;	
	virtual void         init(Sound *sound) = 0;
	virtual void         process(int d, int *playsound) = 0;
	virtual void         uploadline(Screen *screen) = 0;
	virtual void         uploadgfx(Screen *screen) = 0;
	virtual void         render(Screen *screen) = 0;
};
